5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 .
"${source_path}/build/make/configure.sh"
23 ${toggle_libs} libraries
24 ${toggle_examples} examples
25 ${toggle_docs} documentation
26 ${toggle_unit_tests} unit tests
27 ${toggle_decode_perf_tests} build decoder perf tests with unit tests
28 ${toggle_encode_perf_tests} build encoder perf tests with unit tests
29 --cpu=CPU tune for the specified CPU (ARM: cortex-a8, X86: sse3)
30 --libc=PATH path to alternate libc
31 --size-limit=WxH max size to allow in the decoder
32 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
33 --sdk-path=PATH path to root of sdk (android builds only)
34 ${toggle_fast_unaligned} don't use unaligned accesses, even when
35 supported by hardware [auto]
36 ${toggle_codec_srcs} in/exclude codec library source code
37 ${toggle_debug_libs} in/exclude debug version of libraries
38 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
39 ${toggle_vp9_highbitdepth} use VP9 high bit depth (10/12) profiles
40 ${toggle_vp8} VP8 codec support
41 ${toggle_vp9} VP9 codec support
42 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
43 ${toggle_mem_tracker} track memory usage
44 ${toggle_postproc} postprocessing
45 ${toggle_vp9_postproc} vp9 specific postprocessing
46 ${toggle_multithread} multithreaded encoding and decoding
47 ${toggle_spatial_resampling} spatial sampling (scaling) support
48 ${toggle_realtime_only} enable this option while building for real-time encoding
49 ${toggle_onthefly_bitpacking} enable on-the-fly bitpacking in real-time encoding
50 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
51 ${toggle_coefficient_range_checking}
52 enable decoder to check if intermediate
53 transform coefficients are in valid range
54 ${toggle_runtime_cpu_detect} runtime cpu detection
55 ${toggle_shared} shared library support
56 ${toggle_static} static library support
57 ${toggle_small} favor smaller size over speed
58 ${toggle_postproc_visualizer} macro block / block level visualizers
59 ${toggle_multi_res_encoding} enable multiple-resolution encoding
60 ${toggle_temporal_denoising} enable temporal denoising and disable the spatial denoiser
61 ${toggle_vp9_temporal_denoising}
62 enable vp9 temporal denoising
63 ${toggle_webm_io} enable input from and output to WebM container
64 ${toggle_libyuv} enable libyuv
67 Codecs can be selectively enabled or disabled individually, or by family:
70 --disable-<codec>-encoder
71 --disable-<codec>-decoder
73 Codecs available in this distribution:
75 #restore editor state '
81 for c
in ${CODECS}; do
83 if [ "${family}" != "${last_family}" ]; then
84 [ -z "${str}" ] ||
echo "${str}"
85 str
="$(printf ' %10s:' ${family})"
87 str
="${str} $(printf '%10s' ${c#*_})"
95 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
98 # all_platforms is a list of all supported target platforms. Maintain
99 # alphabetically by architecture, generic-gnu last.
100 all_platforms
="${all_platforms} armv6-darwin-gcc"
101 all_platforms
="${all_platforms} armv6-linux-rvct"
102 all_platforms
="${all_platforms} armv6-linux-gcc"
103 all_platforms
="${all_platforms} armv6-none-rvct"
104 all_platforms
="${all_platforms} arm64-darwin-gcc"
105 all_platforms
="${all_platforms} armv7-android-gcc" #neon Cortex-A8
106 all_platforms
="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
107 all_platforms
="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
108 all_platforms
="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
109 all_platforms
="${all_platforms} armv7-none-rvct" #neon Cortex-A8
110 all_platforms
="${all_platforms} armv7-win32-vs11"
111 all_platforms
="${all_platforms} armv7-win32-vs12"
112 all_platforms
="${all_platforms} armv7s-darwin-gcc"
113 all_platforms
="${all_platforms} mips32-linux-gcc"
114 all_platforms
="${all_platforms} mips64-linux-gcc"
115 all_platforms
="${all_platforms} ppc32-darwin8-gcc"
116 all_platforms
="${all_platforms} ppc32-darwin9-gcc"
117 all_platforms
="${all_platforms} ppc32-linux-gcc"
118 all_platforms
="${all_platforms} ppc64-darwin8-gcc"
119 all_platforms
="${all_platforms} ppc64-darwin9-gcc"
120 all_platforms
="${all_platforms} ppc64-linux-gcc"
121 all_platforms
="${all_platforms} sparc-solaris-gcc"
122 all_platforms
="${all_platforms} x86-android-gcc"
123 all_platforms
="${all_platforms} x86-darwin8-gcc"
124 all_platforms
="${all_platforms} x86-darwin8-icc"
125 all_platforms
="${all_platforms} x86-darwin9-gcc"
126 all_platforms
="${all_platforms} x86-darwin9-icc"
127 all_platforms
="${all_platforms} x86-darwin10-gcc"
128 all_platforms
="${all_platforms} x86-darwin11-gcc"
129 all_platforms
="${all_platforms} x86-darwin12-gcc"
130 all_platforms
="${all_platforms} x86-darwin13-gcc"
131 all_platforms
="${all_platforms} x86-iphonesimulator-gcc"
132 all_platforms
="${all_platforms} x86-linux-gcc"
133 all_platforms
="${all_platforms} x86-linux-icc"
134 all_platforms
="${all_platforms} x86-os2-gcc"
135 all_platforms
="${all_platforms} x86-solaris-gcc"
136 all_platforms
="${all_platforms} x86-win32-gcc"
137 all_platforms
="${all_platforms} x86-win32-vs7"
138 all_platforms
="${all_platforms} x86-win32-vs8"
139 all_platforms
="${all_platforms} x86-win32-vs9"
140 all_platforms
="${all_platforms} x86-win32-vs10"
141 all_platforms
="${all_platforms} x86-win32-vs11"
142 all_platforms
="${all_platforms} x86-win32-vs12"
143 all_platforms
="${all_platforms} x86_64-darwin9-gcc"
144 all_platforms
="${all_platforms} x86_64-darwin10-gcc"
145 all_platforms
="${all_platforms} x86_64-darwin11-gcc"
146 all_platforms
="${all_platforms} x86_64-darwin12-gcc"
147 all_platforms
="${all_platforms} x86_64-darwin13-gcc"
148 all_platforms
="${all_platforms} x86_64-iphonesimulator-gcc"
149 all_platforms
="${all_platforms} x86_64-linux-gcc"
150 all_platforms
="${all_platforms} x86_64-linux-icc"
151 all_platforms
="${all_platforms} x86_64-solaris-gcc"
152 all_platforms
="${all_platforms} x86_64-win64-gcc"
153 all_platforms
="${all_platforms} x86_64-win64-vs8"
154 all_platforms
="${all_platforms} x86_64-win64-vs9"
155 all_platforms
="${all_platforms} x86_64-win64-vs10"
156 all_platforms
="${all_platforms} x86_64-win64-vs11"
157 all_platforms
="${all_platforms} x86_64-win64-vs12"
158 all_platforms
="${all_platforms} universal-darwin8-gcc"
159 all_platforms
="${all_platforms} universal-darwin9-gcc"
160 all_platforms
="${all_platforms} universal-darwin10-gcc"
161 all_platforms
="${all_platforms} universal-darwin11-gcc"
162 all_platforms
="${all_platforms} universal-darwin12-gcc"
163 all_platforms
="${all_platforms} universal-darwin13-gcc"
164 all_platforms
="${all_platforms} generic-gnu"
166 # all_targets is a list of all targets that can be configured
167 # note that these should be in dependency order for now.
168 all_targets
="libs examples docs"
170 # all targets available are enabled, by default.
171 for t
in ${all_targets}; do
172 [ -f "${source_path}/${t}.mk" ] && enable_feature ${t}
175 if ! perl --version >/dev/null; then
176 die "Perl is required to build
"
180 if [ "`cd \"${source_path}\" && pwd`" != "`pwd`" ]; then
181 # test to see if source_path already configured
182 if [ -f "${source_path}/vpx_config.h
" ]; then
183 die "source directory already configured
; run
'make distclean' there first
"
187 # check installed doxygen version
188 doxy_version=$(doxygen --version 2>/dev/null)
189 doxy_major=${doxy_version%%.*}
190 if [ ${doxy_major:-0} -ge 1 ]; then
191 doxy_version=${doxy_version#*.}
192 doxy_minor=${doxy_version%%.*}
193 doxy_patch=${doxy_version##*.}
195 [ $doxy_major -gt 1 ] && enable_feature doxygen
196 [ $doxy_minor -gt 5 ] && enable_feature doxygen
197 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable_feature doxygen
200 # install everything except the sources, by default. sources will have
201 # to be enabled when doing dist builds, since that's no longer a common
203 enabled doxygen && enable_feature install_docs
204 enable_feature install_bins
205 enable_feature install_libs
207 enable_feature static
208 enable_feature optimizations
209 enable_feature fast_unaligned #allow unaligned accesses, if supported by hw
210 enable_feature spatial_resampling
211 enable_feature multithread
212 enable_feature os_support
213 enable_feature temporal_denoising
215 [ -d "${source_path}/..
/include
" ] && enable_feature alt_tree_layout
217 [ -d "${source_path}/${d}" ] && disable_feature alt_tree_layout;
220 if ! enabled alt_tree_layout; then
221 # development environment
222 [ -d "${source_path}/vp8
" ] && CODECS="${CODECS} vp8_encoder vp8_decoder
"
223 [ -d "${source_path}/vp9
" ] && CODECS="${CODECS} vp9_encoder vp9_decoder
"
225 # customer environment
226 [ -f "${source_path}/..
/include
/vpx
/vp8cx.h
" ] && CODECS="${CODECS} vp8_encoder
"
227 [ -f "${source_path}/..
/include
/vpx
/vp8dx.h
" ] && CODECS="${CODECS} vp8_decoder
"
228 [ -f "${source_path}/..
/include
/vpx
/vp9cx.h
" ] && CODECS="${CODECS} vp9_encoder
"
229 [ -f "${source_path}/..
/include
/vpx
/vp9dx.h
" ] && CODECS="${CODECS} vp9_decoder
"
230 [ -f "${source_path}/..
/include
/vpx
/vp8cx.h
" ] || disable_feature vp8_encoder
231 [ -f "${source_path}/..
/include
/vpx
/vp8dx.h
" ] || disable_feature vp8_decoder
232 [ -f "${source_path}/..
/include
/vpx
/vp9cx.h
" ] || disable_feature vp9_encoder
233 [ -f "${source_path}/..
/include
/vpx
/vp9dx.h
" ] || disable_feature vp9_decoder
235 [ -f "${source_path}/..
/lib
/*/*mt.lib
" ] && soft_enable static_msvcrt
238 CODECS="$
(echo ${CODECS} |
tr ' ' '\n')"
239 CODEC_FAMILIES="$
(for c
in ${CODECS}; do echo ${c%_*}; done |
sort |
uniq)"
336 vp9_temporal_denoising
337 coefficient_range_checking
396 vp9_temporal_denoising
397 coefficient_range_checking
406 --disable-codecs) for c in ${CODECS}; do disable_feature $c; done ;;
407 --enable-?*|--disable-?*)
408 eval `echo "$opt" | sed 's/--/action=/;s/-/ option=/;s/-/_/g'`
409 if echo "${EXPERIMENT_LIST}" | grep "^
*$option\$
" >/dev/null; then
410 if enabled experimental; then
411 ${action}_feature $option
413 log_echo "Ignoring
$opt -- not
in experimental mode.
"
416 process_common_cmdline $opt
419 *) process_common_cmdline "$opt"
425 post_process_cmdline() {
428 # If the codec family is disabled, disable all components of that family.
429 # If the codec family is enabled, enable all components of that family.
430 log_echo "Configuring selected codecs
"
431 for c in ${CODECS}; do
432 disabled ${c%%_*} && disable_feature ${c}
433 enabled ${c%%_*} && enable_feature ${c}
436 # Enable all detected codecs, if they haven't been disabled
437 for c in ${CODECS}; do soft_enable $c; done
439 # Enable the codec family if any component of that family is enabled
440 for c in ${CODECS}; do
441 enabled $c && enable_feature ${c%_*}
444 # Set the {en,de}coders variable if any algorithm in that class is enabled
445 for c in ${CODECS}; do
446 enabled ${c} && enable_feature ${c##*_}s
452 enabled child || write_common_config_banner
453 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
455 # For fat binaries, call configure recursively to configure for each
456 # binary architecture to be included.
457 if enabled universal; then
458 # Call configure (ourselves) for each subarchitecture
459 for arch in $fat_bin_archs; do
460 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
464 # The write_common_config (config.mk) logic is deferred until after the
465 # recursive calls to configure complete, because we want our universal
466 # targets to be executed last.
467 write_common_config_targets
468 enabled universal && echo "FAT_ARCHS
=${fat_bin_archs}" >> config.mk
470 # Calculate the default distribution name, based on the enabled features
473 for cf in $CODEC_FAMILIES; do
474 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
475 DIST_DIR="${DIST_DIR}-${cf}"
476 elif enabled ${cf}_encoder; then
477 DIST_DIR="${DIST_DIR}-${cf}cx
"
478 elif enabled ${cf}_decoder; then
479 DIST_DIR="${DIST_DIR}-${cf}dx
"
482 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
483 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
484 ! enabled postproc && ! enabled vp9_postproc && DIST_DIR="${DIST_DIR}-nopost"
485 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
486 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
487 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
489 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt
" || DIST_DIR="${DIST_DIR}md
"
490 DIST_DIR="${DIST_DIR}-${tgt_cc}"
493 if [ -f "${source_path}/build
/make
/version.sh
" ]; then
494 ver=`"$source_path/build
/make
/version.sh
" --bare "$source_path"`
495 DIST_DIR="${DIST_DIR}-${ver}"
496 VERSION_STRING=${ver}
498 VERSION_PATCH=${ver##*.}
500 VERSION_MINOR=${ver##*.}
502 VERSION_MAJOR=${ver%.*}
504 enabled child || cat <<EOF >> config.mk
507 ifeq (\$(MAKECMDGOALS),dist)
508 DIST_DIR?=${DIST_DIR}
510 DIST_DIR?=\$(DESTDIR)${prefix}
512 LIBSUBDIR=${libdir##${prefix}/}
514 VERSION_STRING=${VERSION_STRING}
516 VERSION_MAJOR=${VERSION_MAJOR}
517 VERSION_MINOR=${VERSION_MINOR}
518 VERSION_PATCH=${VERSION_PATCH}
520 CONFIGURE_ARGS=${CONFIGURE_ARGS}
522 enabled child || echo "CONFIGURE_ARGS?
=${CONFIGURE_ARGS}" >> config.mk
525 # Write makefiles for all enabled targets
527 for tgt in libs examples docs solution; do
528 tgt_fn="$tgt-$toolchain.mk
"
530 if enabled $tgt; then
531 echo "Creating makefiles
for ${toolchain} ${tgt}"
532 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
540 if enabled shared; then
541 # Can only build shared libs on a subset of platforms. Doing this check
542 # here rather than at option parse time because the target auto-detect
543 # magic happens after the command line has been parsed.
544 if ! enabled linux; then
546 echo "--enable-shared is only supported on ELF
; assuming this is OK
"
548 die "--enable-shared only supported on ELF
for now
"
552 if [ -z "$CC" ] || enabled external_build; then
553 echo "Bypassing toolchain
for environment detection.
"
554 enable_feature external_build
556 log fake_check_header "$@
"
559 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
561 # Headers common to all environments
569 [ -f "${d##-I}/$header" ] && result=true && break
572 esac && enable_feature $var
574 # Specialize windows and POSIX environments.
577 case $header-$toolchain in
580 esac && enable_feature $var
589 esac && enable_feature $var
597 check_header stdio.h || die "Unable to invoke compiler
: ${CC} ${CFLAGS}"
598 check_ld <<EOF || die "Toolchain is unable to link executables
"
599 int main(void) {return 0;}
601 # check system headers
602 check_header stdint.h
603 check_header pthread.h
604 check_header sys/mman.h
605 check_header unistd.h # for sysconf(3) and friends.
607 check_header vpx/vpx_integer.h -I${source_path} && enable_feature vpx_ports
610 process_toolchain() {
611 process_common_toolchain
613 # Handle universal binaries for this architecture
616 darwin_ver=${tgt_os##darwin}
618 # Snow Leopard (10.6/darwin10) dropped support for PPC
619 # Include PPC support for all prior versions
620 if [ $darwin_ver -lt 10 ]; then
621 fat_bin_archs="$fat_bin_archs ppc32-
${tgt_os}-gcc"
624 # Tiger (10.4/darwin8) brought support for x86
625 if [ $darwin_ver -ge 8 ]; then
626 fat_bin_archs="$fat_bin_archs x86-
${tgt_os}-${tgt_cc}"
629 # Leopard (10.5/darwin9) brought 64 bit support
630 if [ $darwin_ver -ge 9 ]; then
631 fat_bin_archs="$fat_bin_archs x86_64-
${tgt_os}-${tgt_cc}"
637 # Enable some useful compiler flags
639 enabled werror && check_add_cflags -Werror
640 check_add_cflags -Wall
641 check_add_cflags -Wdeclaration-after-statement
642 check_add_cflags -Wdisabled-optimization
643 check_add_cflags -Wpointer-arith
644 check_add_cflags -Wtype-limits
645 check_add_cflags -Wcast-qual
646 check_add_cflags -Wvla
647 check_add_cflags -Wimplicit-function-declaration
648 check_add_cflags -Wuninitialized
649 check_add_cflags -Wunused-variable
652 # libvpx and/or clang have issues with aliasing:
653 # https://code.google.com/p/webm/issues/detail?id=603
654 # work around them until they are fixed
655 check_add_cflags -fno-strict-aliasing
657 *) check_add_cflags -Wunused-but-set-variable ;;
659 enabled extra_warnings || check_add_cflags -Wno-unused-function
663 enabled werror && check_add_cflags -Werror
664 check_add_cflags -Wall
665 check_add_cflags -Wpointer-arith
667 # ICC has a number of floating point optimizations that we disable
668 # in favor of deterministic output WRT to other compilers
669 add_cflags -fp-model precise
672 # Enable extra, harmless warnings. These might provide additional insight
673 # to what the compiler is doing and why, but in general, but they shouldn't
674 # be treated as fatal, even if we're treating warnings as errors.
676 -Wdisabled-optimization
679 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
680 RVCT_EXTRA_WARNINGS="
683 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
684 if enabled extra_warnings; then
685 for w in ${EXTRA_WARNINGS}; do
686 check_add_cflags ${w}
687 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
691 # ccache only really works on gcc toolchains
692 enabled gcc || soft_disable ccache
693 if enabled mips; then
694 enable_feature dequant_tokens
695 enable_feature dc_recon
698 if enabled internal_stats; then
699 enable_feature vp9_postproc
702 # Enable the postbuild target if building for visual studio.
704 vs*) enable_feature msvs
705 enable_feature solution
706 vs_version=${tgt_cc##vs}
710 gen_vcproj_cmd=${source_path}/build/make/gen_msvs_proj.sh
714 gen_vcproj_cmd=${source_path}/build/make/gen_msvs_vcxproj.sh
715 enabled werror && gen_vcproj_cmd="${gen_vcproj_cmd} --enable-werror"
718 all_targets="${all_targets} solution
"
719 INLINE="__forceinline
"
723 # Other toolchain specific defaults
724 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
726 if enabled postproc_visualizer; then
727 enabled postproc || die "postproc_visualizer requires postproc to be enabled
"
730 # Enable unit tests by default if we have a working C++ compiler.
733 soft_enable unit_tests
740 # GTestLog must be modified to use Android logging utilities.
743 # iOS/ARM builds do not work with gtest. This does not match
751 # Some mingw toolchains don't have pthread available by default.
752 # Treat these more like visual studio where threading in gtest
753 # would be disabled for the same reason.
754 check_cxx "$@
" <<EOF && soft_enable unit_tests
757 check_cxx "$@
" <<EOF && soft_enable webm_io
760 check_cxx "$@
" <<EOF && soft_enable libyuv
765 enabled pthread_h && check_cxx "$@
" <<EOF && soft_enable unit_tests
768 check_cxx "$@
" <<EOF && soft_enable webm_io
771 check_cxx "$@
" <<EOF && soft_enable libyuv
776 # libwebm needs to be linked with C++ standard library
777 enabled webm_io && LD=${CXX}
782 ## END APPLICATION SPECIFIC CONFIGURATION
786 print_webm_license ${BUILD_PFX}vpx_config.c "/*" " */"
787 cat <<EOF >> ${BUILD_PFX}vpx_config.c
788 static const char* const cfg = "$CONFIGURE_ARGS";
789 const char *vpx_codec_build_config(void) {return cfg;}